package net.pricefx.common.dto.creationworkflow;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class CreationWorkflowDefinition {

	private List<CreationWorkflowStepDefinition> steps = new ArrayList<>();
	private Integer requestedCurrentStep = null;

	public List<CreationWorkflowStepDefinition> getSteps() {
		return steps;
	}

	public CreationWorkflowDefinition withSteps(CreationWorkflowStepDefinition... steps) {
		this.steps.addAll(Arrays.asList(steps));
		return this;
	}

	public void resetCurrentStepTo(int step) {
		requestedCurrentStep = step;
	}

	// private api

	public Integer getRequestedCurrentStep() {
		return requestedCurrentStep;
	}
}
