package net.pricefx.logic.core.formulamanager;

import com.fasterxml.jackson.core.type.TypeReference;
import net.pricefx.logic.core.model.AbstractFormula;
import net.pricefx.logic.core.model.ContextParameter;
import net.pricefx.restapiclient.PfxClient;
import net.pricefx.restapiclient.PfxClientException;
import net.pricefx.restapiclient.model.BaseMap;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class TestParams extends net.pricefx.restapiclient.calls.formulamanager.TestParams {
    public TestParams(PfxClient client, AbstractFormula logic, Map<String, Object> params) {
        super(client, logic.getNode(), params);
    }

    @Override
    public List<ContextParameter> execute() throws PfxClientException {
        List<BaseMap> responseList = super.execute();
        try {
            List<ContextParameter> result = PfxClient.DEFAULT_OBJECT_MAPPER.convertValue(responseList, new TypeReference<ArrayList<ContextParameter>>() {});
            return result == null ? new ArrayList<>() : result;
        } catch (IllegalArgumentException e) {
            throw new PfxClientException("getFormulaTestParams: Cannot convert response to List<ContextParameter>");
        }
    }
}
